program I20TEST; { 4I20 rotating bit test }

var fookey : word;

{$I 4I20low}
{$I General}
{$I hexread}

procedure SetEmAll(state : boolean);
var thebit : byte;
begin
  for thebit := 0 to 23 do BitOut(thebit,state);
end;

procedure Usage;
begin
  writeln;
  writeln('USAGE: 4I20TEST XXXX');
  writeln('Where XXXX is the hex base address of the 4I20 to be tested');
  writeln;
  writeln('FUNCTION: Rotating Ones and Zeros test of 4I20 I/O card');
  halt(2);
end;

procedure BarfOut(s: string);
begin
  PowerDown4I20;
  writeln;
  writeln(chr(7),s);
  Halt(2);
end;

function GetParms : boolean;
begin
  GetParms := false;
  if ParamCount = 1 then
  begin
    if HexwordRead(ParamStr(1),I20Port) then
    begin
      if (I20Port > $FF) and (I20Port < $3FD) then
      begin
        GetParms := true;
      end
      else Barfout('Out of range port address');
    end
    else BarfOut('Undecipherable port address')
  end;
end;


procedure ReportBitError(thebit: byte;thecomplaint : string);
var bstring : string;
begin
  str(thebit,bstring);
  Barfout('Bit '+bstring+' error -> '+thecomplaint);
end;

procedure RotateOneTest;
var
wbit : byte;
rbit : byte;
begin
  SetEmAll(false);
  for wbit := 0 to 23 do
  begin
    BitOut(wbit,true);
    for rbit := 0 to 23 do
    begin
      if rbit <> wbit then
      begin
        if BitIn(rbit) then ReportBitError(rbit,'Unexpected ON during rotate one test');
      end
      else
      begin
        if not BitIn(rbit) then ReportBitError(rbit,'Unexpected OFF during rotate one test');
      end;
    end;
    BitOut(wbit,false);
  end;
end;


procedure RotateZeroTest;
var
wbit : byte;
rbit : byte;
begin
  SetEmAll(true);
  for wbit := 0 to 23 do
  begin
    BitOut(wbit,false);
    for rbit := 0 to 23 do
    begin
      if rbit <> wbit then
      begin
        if not BitIn(rbit) then ReportBitError(rbit,'Unexpected OFF during rotate zero test');
      end
      else
      begin
        if BitIn(rbit) then ReportBitError(rbit,'Unexpected ON during rotate zero test');
      end;
    end;
    BitOut(wbit,true);
  end;
end;

begin
  if not GetParms then usage;
  { CardThere check does implicit 4I20 initialization }
  if not CardThere then BarfOut('4I20 card not found!');
  writeln('Each * is one pass');
  writeln('Press any key to abort...');
  while not keypressed do
  begin
    RotateOneTest;
    RotateZeroTest;
    write('*');
  end;
  PowerDown4I20;
  fookey := ReadKey;
end.
